# frozen_string_literal: true

module LetItCrash
  class Formatter
    def initialize(rewriter: nil, reporters: [Reporters::Upload.from_env])
      @rewriter = rewriter
      @reporters = reporters
    end

    def format(result)
      report = Builders::ReportBuilder.build(
        environment: ENV,
        result: result,
        rewriter: rewriter,
      )
      reporters.each { |reporter| reporter.report(report) }
    end

    # This unfortunate trick is required since SimpleCov expects formatters to
    # be classes rather than instances, and calls `new` on them.
    def new
      self
    end

    private

    attr_reader :rewriter, :reporters
  end # class Formatter
end # module LetItCrash
