# frozen_string_literal: true

module LetItCrash
  module Matchers
    class Base
      def initialize(environment:)
        @environment = environment
      end

      def matches?
        raise NotImplementedError
      end

      def branch
        raise NotImplementedError
      end

      def sha
        raise NotImplementedError
      end

      private

      attr_reader :environment

      def ci?
        environment['CI'] == 'true'
      end
    end # class Base
  end # module Matchers
end # module LetItCrash
