# frozen_string_literal: true

module LetItCrash
  module Matchers
    class Git < Base
      STATUS_CMD = 'git status'
      BRANCH_CMD = 'git rev-parse --abbrev-ref HEAD'
      SHA_CMD    = 'git rev-parse HEAD'

      # This method reeks of :reek:UtilityFunction.
      def matches?
        IO.popen(STATUS_CMD).read.start_with?('On branch')
      end

      # This method reeks of :reek:UtilityFunction.
      def branch
        ret = IO.popen(BRANCH_CMD).read.strip
        ret == 'HEAD' ? 'master' : ret
      end

      # This method reeks of :reek:UtilityFunction.
      def sha
        IO.popen(SHA_CMD).read.strip
      end
    end # class Git
  end # module Matchers
end # module LetItCrash
