# frozen_string_literal: true

module LetItCrash
  module Matchers
    class GitLabCI < Base
      # This method performs a :reek:NilCheck.
      def matches?
        !environment['GITLAB_CI'].nil?
      end

      def branch
        environment['CI_BUILD_REF_NAME'] || environment['CI_COMMIT_REF_NAME']
      end

      def sha
        environment['CI_BUILD_REF'] || environment['CI_COMMIT_SHA']
      end
    end # class GitLabCI
  end # module Matchers
end # module LetItCrash
